#         Script : serials v1.00 by David Proper (Dr. Nibble [DrN])
#                  Copyright 2000-2002 Radical Computer Systems
#
# Original Platform : Linux 2.0.36
#                     Eggdrop v1.2.0+bel1
# Testing Platforms : Linux 2.2.16  (TCL v8.3)
#                     Eggdrop v1.6.6
#               And : SunOS 5.8  (TCL v8.3)
#                     Eggdrop v1.5.4
#
#    Description : Serials is another lame little tcl. All it does is
#                  provide a search function on a flat text file.
#                  Defualt setup is for a list of serial codes.
#
# Originally written 2 years ago. Never thought it was really worth
# releasing. But what the hell.
#        History : 03/29/2002 - First Release
#
#
#   Future Plans : o None at the moment.
#
#
# Author Contact :     Email - DProper@stx.rr.com
#                  Home Page - http://home.stx.rr.com/dproper
#                        IRC - Primary Nick: DrN
#                     UseNet - alt.irc.bots.eggdrop
# Support Channels: #RCS @UnderNet.Org
#                   #RCS @DALnet
#                   #RCS @EFnet (Not sure if this will be perm or not)
#                   #RCS @GalaxyNet (Not sure if this will be perm or not)
#
# New TCL releases are sent to the following sites as soon as they're released:
#
# FTP Site                   | Directory                     
# ---------------------------+-------------------------------
# ftp.chaotix.net            | /pub/RCS                      
# ftp.eggheads.org           | Various                       
# http://www.botcentral.net  | Various                       
# drn.realmweb.org           | /drn                          
#
#   Radical Computer Systems - http://www.chaotix.net:3000/rcs/
#
# To subscribe to the RCS mailing list: mail majordomo@chaotix.net and in
#  BODY of message, type  subscribe rcs-list
#
#  Feel free to Email me any suggestions/bug reports/etc.
#
# You are free to use this TCL/script as long as:
#  1) You don't remove or change author credit
#  2) You don't release it in modified form. (Only the original)
#
# If you have a "too cool" modification, send it to me and it'll be
# included in the official. (With your credit)
#
# Commands Added:
#  Where     F CMD       F CMD         F CMD        F CMD
#  -------   - --------- - ----------- - ---------- - --------- - -------
#  Public:   - !serial   - @find       - !serials   - !search   - @search
#            - !list
#     MSG:   - serial
#     DCC:   
#
#
# Big thanks to LtGen of #tcl (UnderNet) for answering a question I had

set serialver "v1.00.01"
set cmdchar_ "!"
set maxsearch 20
set serialdata "~/.serials"
set serialcontrib "To contribute to the list, send any serials to serials@chaotix.net"

proc cmdchar { } {
 global cmdchar_
 return $cmdchar_
}

bind pub - !serials pub_serialinform
bind pub - @find pub_serialinform
bind pub - @search pub_serialinform
bind pub - !search pub_serialinform
bind pub - !list pub_serialinform

proc pub_serialinform {nick uhost handle chan args} {
  global urlfile prefix totfound serialcontrib
    puthelp "NOTICE $nick :To search the serial database: [cmdchar]serial keyword"
    puthelp "NOTICE $nick :$serialcontrib"
  return 1
}



bind pub - [cmdchar]serial pub_serialsearch
proc pub_serialsearch {nick uhost handle chan args} {
  global urlfile prefix totfound
  if {[lindex $args 0] != ""} {

 set a [lindex $args 0]
 set b [lindex $a 0]
 set c [lrange $a 1 end]
 foreach ab $c {
  append b "*"
  append b $ab
               }

  doserialsearch $nick $b
  } else {
    puthelp "NOTICE $nick :Syntax: !serial <search string>"
  }
  return 1
}


proc msg_serialsearch {nick uhost handle args} {
  global urlfile prefix botnick totfound
  if {[lindex $args 0] != ""} {
 set a [lindex $args 0]
 set b [lindex $a 0]
 set c [lrange $a 1 end]
 foreach ab $c {
 append b "*"
 append b $ab
 }
  doserialsearch $nick $b
  } else {
    puthelp "NOTICE $nick :Syntax: /msg $botnick serial <search string>"
  }
  return 1
}

bind msg - serial msg_serialsearch

proc doserialsearch {nick data} {
global serialver maxsearch serialdata
    putserv "NOTICE $nick :Serial Search $serialver by DrN"
    putserv "NOTICE $nick :Searching Main Database for \"$data\""
      if {$maxsearch != 0} {putserv "NOTICE $nick :There is a limit of $maxsearch results in effect."}
    set data [string tolower $data]

##### If you want more databases, uncomment and edit the following as needed
#    putserv "NOTICE $nick :Searching ? Database for \"$data\""
#    searchserials $nick Path_To_?_Database $data

}

proc searchserials {nick database data} {
 global maxsearch
    set in [open $database r]
    set totfound 0

    while {![eof $in]} {
      set line [gets $in]
      if {[string match "*$data*" [string tolower $line]]} {
        puthelp "NOTICE $nick :$line"
      if {$totfound > $maxsearch} {
                  puthelp "NOTICE $nick :There are over $maxsearch matches. Please norrow your search."
                  close $in
                  return 0
                                   }
        set totfound [expr $totfound + 1]
     }
    }
    close $in
    puthelp "NOTICE $nick :There was a total of $totfound entries matching your query."

}

putlog "Serials $serialver by David Proper (DrN) -: LoadeD :-"
return "Serials $serialver by David Proper (DrN) -: LoadeD :-"

